void j_script_ok(gtkwidget *widget,gpointer data){
    gtk_entry_set_text(gtk_entry(data),gtk_file_selection_get_filename(gtk_file_selection(filew)));
    sprintf(script_file,gtk_file_selection_get_filename(gtk_file_selection(filew)));
    gtk_widget_destroy(filew);
}    

void j_script_file(gtkwidget *widget,gpointer data){
    filew=gtk_file_selection_new("script file");
    gtk_file_selection_set_filename(gtk_file_selection(filew),"");
    gtk_signal_connect(gtk_object(gtk_file_selection(filew)->ok_button),"clicked",gtk_signal_func(j_script_ok),data);
    gtk_signal_connect_object(gtk_object(gtk_file_selection(filew)->cancel_button),"clicked",gtk_signal_func(gtk_widget_destroy),gtk_object(filew));
    gtk_widget_show(filew);
}    

void j_bad_ok(gtkwidget *widget,gpointer data){
    gtk_entry_set_text(gtk_entry(data),gtk_file_selection_get_filename(gtk_file_selection(filew)));
    sprintf(bad_file,gtk_file_selection_get_filename(gtk_file_selection(filew)));
    gtk_widget_destroy(filew);
}    

void j_bad_file(gtkwidget *widget,gpointer data){
    filew=gtk_file_selection_new("bad file");
    gtk_file_selection_set_filename(gtk_file_selection(filew),"");
    gtk_signal_connect(gtk_object(gtk_file_selection(filew)->ok_button),"clicked",gtk_signal_func(j_bad_ok),data);
    gtk_signal_connect_object(gtk_object(gtk_file_selection(filew)->cancel_button),"clicked",gtk_signal_func(gtk_widget_destroy),gtk_object(filew));
    gtk_widget_show(filew);
}

int j_read_query(int f,char *buffer){
    int x=0;
    int j;
    char y;
    while((j=read(f,&y,1))>0){
	if(y=='#'){
	    while(1){
		j=read(f,&y,1);
		if(y=='\n'){
		    break;
		}
	    }
	}        	        
	else{
	    if(y!=';'){
		buffer[x++]=y;
    	    }
	    if(y=='\n'){
		buffer[x++]=' ';
		//continue;
	    }
	    if(y==';'){
		buffer[x++]='\0';
		return x;
	    }
	}        
    }
    if(j==-1){
	mysql_alert("file read error\n");
	exit(1);
    }
    if(j==0){
	//buffer[x]='\0';
	return 0;
    }	
}    	

void j_bad_log(char *error){
    int f;
    int x=0;
    char y[300];
    time_t t;
    time(&t);
    f=open(bad_file,o_creat|o_excl|o_rdwr|o_append,0666);
    if(f==-1){
	f=open(bad_file,o_rdwr|o_append);
    }
    sprintf(y,"time: %suser: %s\nerror: %s\nquery: %s\n\n",log_time?ctime(&t):"\n",log_user?user:"",log_error?mysql_error(&my_sql):"",error);
    x=write(f,y,strlen(y));
    close(f);
}    	

void j_run_script(gtkwidget *widget,gpointer data){
    int y=1;
    int f;
    char buffer[1000];
    int success=0;
    int fail=0;
    
    if(strlen(script_file)==0){
	mysql_alert("you must enter script file");
	return;
    }
    if(strlen(bad_file)==0){
	mysql_alert("you must enter bad file");
	return;
    }
    f=open(script_file,o_rdonly);
    if(f==-1){
	mysql_alert("file read error\n");
	return;
    }
    while(j_read_query(f,buffer)){
	if(mysql_query(&my_sql,buffer)){
	    j_bad_log(buffer);
	    fail++;
	    continue;
	}
	else{
	    success++;
	}    
    }
    init_db();
    init_tree();
    sprintf(buffer,"total: %d\tsuccess: %d\tfail: %d\n",fail+success,success,fail);
    gtk_label_set_text(gtk_label(data),buffer);
    close(f);
}    

void j_make_run_page(gtkwidget *widget){
    gtkwidget *vbox;
    gtkwidget *frame;
    gtkwidget *h_box;
    gtkwidget *entry;
    gtkwidget *bad;
    gtkwidget *button;
    gtkwidget *label;
    
    vbox=gtk_vbox_new(false,10);
    gtk_widget_show(vbox);
    gtk_container_set_border_width(gtk_container(vbox),10);
    gtk_container_add(gtk_container(widget),vbox);
    
    frame=gtk_frame_new(hangul?"ũƮ ":"script file");
    gtk_widget_show(frame);
    gtk_box_pack_start(gtk_box(vbox),frame,false,true,0);
    
    h_box=gtk_hbox_new(false,0);
    gtk_container_set_border_width(gtk_container(h_box),5);
    gtk_widget_show(h_box);
    gtk_container_add(gtk_container(frame),h_box);
    
    entry=gtk_entry_new();
    gtk_entry_set_text(gtk_entry(entry),script_file);
    gtk_entry_set_editable(gtk_entry(entry),false);
    gtk_widget_show(entry);
    gtk_box_pack_start(gtk_box(h_box),entry,true,true,0);
    
    button=gtk_button_new_with_label("...");
    gtk_widget_show(button);
    gtk_box_pack_start(gtk_box(h_box),button,false,false,0);
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(j_script_file),(gpointer)entry);
    
    frame=gtk_frame_new(hangul?" ":"bad file");
    gtk_widget_show(frame);
    gtk_box_pack_start(gtk_box(vbox),frame,false,false,0);
    
    h_box=gtk_hbox_new(false,0);
    gtk_container_set_border_width(gtk_container(h_box),5);
    gtk_widget_show(h_box);
    gtk_container_add(gtk_container(frame),h_box);
    
    bad=gtk_entry_new();
    gtk_entry_set_text(gtk_entry(bad),bad_file);
    gtk_entry_set_editable(gtk_entry(bad),false);
    gtk_widget_show(bad);
    gtk_box_pack_start(gtk_box(h_box),bad,true,true,0);
    
    button=gtk_button_new_with_label("...");
    gtk_widget_show(button);
    gtk_box_pack_start(gtk_box(h_box),button,false,false,0);
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(j_bad_file),(gpointer)bad);
    
    frame=gtk_frame_new(hangul?"Ѱ":"total");
    gtk_container_set_border_width(gtk_container(frame),0);
    gtk_box_pack_start(gtk_box(vbox),frame,false,false,0);    
    gtk_widget_show(frame);
    label=gtk_label_new("\n");
    gtk_label_set_justify(gtk_label(label),gtk_justify_left);
    gtk_widget_show(label);
    gtk_container_add(gtk_container(frame),label);
    
    button=gtk_button_new_with_label(hangul?"":"run");
    gtk_widget_set_usize(button,30,25);
    gtk_signal_connect(gtk_object(button),"clicked",gtk_signal_func(j_run_script),(gpointer)label);
    gtk_widget_show(button);
    gtk_box_pack_start(gtk_box(vbox),button,false,false,0);
}    
